clc,clear,close all
addpath(genpath('../'));
load('ITP35_d150f_Sept12d_smth');
load('sim_9k_old');load('sim_9k_new');
load('sim_36km_old');load('sim_36km_new');
nlvl = 3;
depth = ncread('/media/arash/Arash2/post_code/grid.glob_A1.nc','Depth');
lon_d = ncread('/media/arash/Arash2/post_code/grid.glob_A1.nc','XC');
lat_d = ncread('/media/arash/Arash2/post_code/grid.glob_A1.nc','YC');
load('/media/arash/SSD512/Post proc/fwaterPoster_newMCphee/mcphee/Mooring/local_out/mooring_c.mat');


% figure
subplot 221
h = worldmap([70 80],[-170 -110]);
geoshow('landareas.shp', 'FaceColor', 'none');
setm(h,'mlabellocation',10)
my_SI_map(sim_36km_new.lat,sim_36km_new.lon,sim_36km_new.ai)
% quivermc(sim_36km_new.lat,sim_36km_old.lon,sim_36km_new.u_r(:,:,nlvl),sim_36km_new.v_r(:,:,nlvl),'units','m/s','reference',0.05)
title('A1')

% figure
subplot 222
h = worldmap([70 80],[-170 -110]);
geoshow('landareas.shp', 'FaceColor', 'none');
setm(h,'mlabellocation',10)
my_SI_map(sim_9k_new.lat,sim_9k_new.lon,sim_9k_new.ai)
% quivermc(sim_9k_new.lat,sim_9k_old.lon,sim_9k_new.u_r(:,:,nlvl),sim_9k_new.v_r(:,:,nlvl),'units','m/s','reference',0.05)
title('A2')

subplot 223

figure
% subplot 144
h = worldmap([70 80],[-170 -120]);
geoshow('landareas.shp', 'FaceColor', 'none');
setm(h,'mlabellocation',10)
pcolorm(lat_d,lon_d,depth);caxis([0 4000])
% colormap('jet')
colorbar('horizental');
plotm(d150.lat,d150.lon,'k','linewidth',2)
textm(d150.lat(1),d150.lon(1),'ITP-v')
for i = 1:3
plotm(mooring_c.loc{i},'rx','markersize',10);
textm(mooring_c.loc{i}(1),mooring_c.loc{i}(2),mooring_c.name{i})
end

% plotm(


% addpath('local_fun/')
%values used in the code
my_offset = -0;
dt_1 = 3600*24;
a_block_1 = 1;
dt_2 = 3600*6;
% a_block_2 = 4*a_block_1;
a_block_2 = 1;
depth_block = [5 60];
h = depth_block(end) - depth_block(1);
low_pass1 = 4;
low_pass2 = low_pass1*4;

warning('off','MATLAB:interp1:NaNstrip');

load('itp_35_post_36km_mcphee.mat')
sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');
sim.rho = gsw_rho(sim.s,sim.T,sim.dz);
data.rho = gsw_rho(data.s,data.T,data.p);
% calculating ML
for n = 1:size(data.time,2)
    
    [data.ml2(n),data.first_val(n),~,data.ml(n)] = mld_finder(data.p(:,n),data.rho(:,n),0.1,0.02,0.2);
    tmp = squeeze(sim.rho(:,n));
    tmp(sim.dz<data.first_val(n)) = NaN;
%     [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,sim.rho(:,n),0.1,0.02,0.2);
        [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,tmp,0.1,0.02,0.2);
end
%%%low pass
for k=1:size(data.u,1)
    data.u(k,:) = my_lowpass(data.u(k,:),low_pass1);
    data.v(k,:) = my_lowpass(data.v(k,:),low_pass1);
end

for k=1:size(sim.u,1)
    sim.u(k,:) = my_lowpass(sim.u(k,:),low_pass1);
    sim.v(k,:) = my_lowpass(sim.v(k,:),low_pass1);
end

sim_mcphee = sim;
clear sim
data_old = data;

load('itp_35_post_36km_old.mat')
sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');
sim.rho = gsw_rho(sim.s,sim.T,sim.dz);
data.rho = gsw_rho(data.s,data.T,data.p);
% calculating ML
for n = 1:size(data.time,2)
    
    [data.ml2(n),data.first_val(n),~,data.ml(n)] = mld_finder(data.p(:,n),data.rho(:,n),0.1,0.02,0.2);
    tmp = squeeze(sim.rho(:,n));
    tmp(sim.dz<data.first_val(n)) = NaN;
%     [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,sim.rho(:,n),0.1,0.02,0.2);
            [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,tmp,0.1,0.02,0.2);
    
end

sim_old = sim;
clear sim

load('itp_35_post_9k.mat')
% load('itp_35_post_preMcphee.mat')

sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');


sim.rho = gsw_rho(sim.s,sim.T,sim.dz);
data.rho = gsw_rho(data.s,data.T,data.p);
% calculating ML
for n = 1:size(data.time,2)
    
    [data.ml2(n),data.first_val(n),~,data.ml(n)] = mld_finder(data.p(:,n),data.rho(:,n),0.1,0.02,0.2);
    tmp = squeeze(sim.rho(:,n));
    tmp(sim.dz<data.first_val(n)) = NaN;
%     [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,9k.rho(:,n),0.1,0.02,0.2);
        [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,tmp,0.1,0.02,0.2);
    
end

sim_9km = sim;
data_9km = data;

%
%here I changed 6 hours to 24 hours
%

t_vec = sim_old.time;
for n = 1:size(sim_9km.T,1)
    foo.T(n,:) = interp1(sim_9km.time,sim_9km.T(n,:),t_vec);
    foo.s(n,:) = interp1(sim_9km.time,sim_9km.s(n,:),t_vec);
    foo.u(n,:) = interp1(sim_9km.time,sim_9km.u(n,:),t_vec);
    foo.v(n,:) = interp1(sim_9km.time,sim_9km.v(n,:),t_vec);
    foo.rho(n,:) = interp1(sim_9km.time,sim_9km.rho(n,:),t_vec);
end
foo.ml = interp1(sim_9km.time,sim_9km.ml,t_vec);
sim_9km.time = t_vec;
data_9km = data_old;
sim_9km.T = foo.T; sim_9km.s = foo.s; sim_9km.u = foo.u;
sim_9km.v = foo.v; sim_9km.rho = foo.rho; sim_9km.ml = foo.ml;


% plotting ML figure 2

% subplot 143
figure
plot(data.time,data.ml,'k');hold on;
% plot(sim_old.time,sim_old.ml);
plot(sim_old.time,sim_mcphee.ml,'b');
plot(sim_9km.time,sim_9km.ml,'r');
datetick('x','mmm');axis tight;
ylim ([0 50]);ylabel('MLD');xlabel('Days')
set(gca,'ydir','reverse')
legend('data','A1','A2')
title('ML')

subplot 221
h = worldmap([70 80],[-170 -110]);
geoshow('landareas.shp', 'FaceColor', 'none');
setm(h,'mlabellocation',10)
my_SI_map(sim_36km_new.lat,sim_36km_new.lon,sim_36km_new.ai)
% quivermc(sim_36km_new.lat,sim_36km_old.lon,sim_36km_new.u_r(:,:,nlvl),sim_36km_new.v_r(:,:,nlvl),'units','m/s','reference',0.05)
title('(\it{a}) A1')

% figure
subplot 222
h = worldmap([70 80],[-170 -110]);
geoshow('landareas.shp', 'FaceColor', 'none');
setm(h,'mlabellocation',10)
my_SI_map(sim_9k_new.lat,sim_9k_new.lon,sim_9k_new.ai)
% quivermc(sim_9k_new.lat,sim_9k_old.lon,sim_9k_new.u_r(:,:,nlvl),sim_9k_new.v_r(:,:,nlvl),'units','m/s','reference',0.05)
title('(\it{b}) A2')

subplot 223
plot(data.time,data.ml,'k');hold on;
% plot(sim_old.time,sim_old.ml);
plot(sim_old.time,sim_mcphee.ml,'b');
plot(sim_9km.time,sim_9km.ml,'r');
datetick('x','mmm');axis tight;
ylim ([0 50]);ylabel('MLD');xlabel('Days')
set(gca,'ydir','reverse')
legend('data','A1','A2')
title('(\it{c}) ML')

