clear, close all,clc
addpath('local_fun/')
%values used in the code
my_offset = -0;
dt_1 = 3600*24;
a_block_1 = 1;
dt_2 = 3600*6;
% a_block_2 = 4*a_block_1;
a_block_2 = 1;
depth_block = [5 60];
h = depth_block(end) - depth_block(1);
low_pass1 = 4;
low_pass2 = low_pass1*4;

warning('off','MATLAB:interp1:NaNstrip');

load('itp_35_post_36km_mcphee.mat')
sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');
%%%low pass
% for k=1:size(data.u,1)
%     data.u(k,:) = my_lowpass(data.u(k,:),low_pass1);
%     data.v(k,:) = my_lowpass(data.v(k,:),low_pass1);
% end
% 
% for k=1:size(sim.u,1)
%     sim.u(k,:) = my_lowpass(sim.u(k,:),low_pass1);
%     sim.v(k,:) = my_lowpass(sim.v(k,:),low_pass1);
% end

sim_mcphee = sim;
clear sim
data_old = data;

load('itp_35_post_36km_old.mat')
sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');
sim.rho = gsw_rho(sim.s,sim.T,sim.dz);
data.rho = gsw_rho(data.s,data.T,data.p);

sim_old = sim;
clear sim

load('itp_35_post_9k.mat')
sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');

sim_9km = sim;
data_9km = data;

%
%here I changed 6 hours to 24 hours
%

t_vec = sim_old.time;
for n = 1:size(sim_9km.T,1)
    foo.u(n,:) = interp1(sim_9km.time,sim_9km.u(n,:),t_vec);
    foo.v(n,:) = interp1(sim_9km.time,sim_9km.v(n,:),t_vec);
end
sim_9km.time = t_vec;
data_9km = data_old;
sim_9km.u = foo.u;
sim_9km.v = foo.v;

% cal fluxes
flux_dz = depth_block(1):depth_block(end);
for i = 1:size(data_9km.p,2)
    foo_u = squeeze(data_9km.u(:,i));
    foo_v = squeeze(data_9km.v(:,i));
    foo_p = squeeze(data_9km.p(:,i));
    foo_u = foo_u(~isnan(foo_p));
    foo_v = foo_v(~isnan(foo_p));
    foo_p = foo_p(~isnan(foo_p))-my_offset;
    
    d_u1(:,i) = interp1(foo_p,foo_u,flux_dz,'pchip');
    d_v1(:,i) = interp1(foo_p,foo_v,flux_dz,'pchip');
    
    s_u(:,i) = interp1(sim_9km.dz,sim_9km.u(:,i),flux_dz,'pchip');
    s_v(:,i) = interp1(sim_9km.dz,sim_9km.v(:,i),flux_dz,'pchip');
end
d_u1(abs(d_u1)>2) = NaN;
d_v1(abs(d_v1)>2) = NaN;

data_9km.uflux = avdat(nansum(d_u1,1),a_block_2);
data_9km.vflux = avdat(nansum(d_v1,1),a_block_2);
sim_9km.uflux = avdat(nansum(s_u,1),a_block_2);
sim_9km.vflux = avdat(nansum(s_v,1),a_block_2);

for i = 1:size(data_old.p,2)
    
    foo_u = squeeze(data_old.u(:,i));
    foo_v = squeeze(data_old.v(:,i));
    foo_p = squeeze(data_old.p(:,i));
    foo_u = foo_u(~isnan(foo_p));
    foo_v = foo_v(~isnan(foo_p));
    foo_p = foo_p(~isnan(foo_p))-my_offset;
    d_u2(:,i) = interp1(foo_p,foo_u,flux_dz,'pchip');
    d_v2(:,i) = interp1(foo_p,foo_v,flux_dz,'pchip');
    
    s_u_old(:,i) = interp1(sim.dz,sim_old.u(:,i),flux_dz,'pchip');
    s_v_old(:,i) = interp1(sim.dz,sim_old.v(:,i),flux_dz,'pchip');
    s_u_new(:,i) = interp1(sim.dz,sim_mcphee.u(:,i),flux_dz,'pchip');
    s_v_new(:,i) = interp1(sim.dz,sim_mcphee.v(:,i),flux_dz,'pchip');
    
end
d_u2(abs(d_u2)>2) = NaN;
d_v2(abs(d_v2)>2) = NaN;

%%%% AVDAT HERE
data_old.uflux = avdat(nansum(d_u2,1),a_block_1);
data_old.vflux = avdat(nansum(d_v2,1),a_block_1);

sim_old.uflux = avdat(nansum(s_u_old,1),a_block_1);
sim_old.vflux = avdat(nansum(s_v_old,1),a_block_1);
sim_mcphee.uflux = avdat(nansum(s_u_new,1),a_block_1);
sim_mcphee.vflux = avdat(nansum(s_v_new,1),a_block_1);

%cal error in distance
[sim_old.dist,sim_old.daily_err] = ...
    daily_err_cal(sim_old.uflux,data_old.uflux...
    ,sim_old.vflux,data_old.vflux,a_block_1,h,dt_1);
[sim_mcphee.dist,sim_mcphee.daily_err] = ...
    daily_err_cal(sim_mcphee.uflux,data_old.uflux...
    ,sim_mcphee.vflux,data_old.vflux,a_block_1,h,dt_1);
[sim_9km.dist,sim_9km.daily_err] = ...
    daily_err_cal(sim_9km.uflux,data_9km.uflux...
    ,sim_9km.vflux,data_9km.vflux,a_block_2,h,dt_2);
[sanity.dist,sanity.daily_err] =     daily_err_cal(0.*sim_9km.uflux,data_9km.uflux...
    ,0.*sim_9km.vflux,data_9km.vflux,a_block_2,h,dt_2);
%plotting error
figure;subplot 211;hold on;
plot(sim_old.time,sim_old.dist./1E3);
plot(sim_old.time,sim_mcphee.dist./1E3);
plot(sim_9km.time,sim_9km.dist./1E3,'k');
% plot(sim_9km.time,sanity.dist./1E3,'g');
legend('old','new','9km','1D model')
datetick('x','mmm'),grid minor;
axis tight
ylabel('Error in distance (Km)')

subplot 212, hold on
plot(sim_old.time,sim_old.daily_err./1E3);
plot(sim_old.time,sim_mcphee.daily_err./1E3);
plot(sim_9km.time,sim_9km.daily_err./1E3,'k');
ylabel('daily error (Km)');datetick('x','mmm')
axis tight;ylim ([0 15]);legend('old','new','9km');grid minor;


%plotting vel profiles
data_old.u(data_old.u >=1) = 0;
data_old.v(data_old.v >=1) = 0;

figure
subplot 221
plot(nanmean(data_old.s,2),nanmean(data_old.p,2))
hold on;plot(nanmean(sim_old.s,2),nanmean(sim_old.dz,2));
plot(nanmean(sim_mcphee.s,2),nanmean(sim_mcphee.dz,2));
plot(nanmean(sim_9km.s,2),nanmean(sim_9km.dz,2),'k');
ylim([0 60])
set(gca,'ydir','reverse')
legend('data','old','new','9km','location','southwest')
xlabel('Salinity')

subplot 222
plot(nanmean(data_old.T,2),nanmean(data_old.p,2))
hold on;plot(nanmean(sim_old.T,2),nanmean(sim_old.dz,2));
plot(nanmean(sim_mcphee.T,2),nanmean(sim_mcphee.dz,2));
plot(nanmean(sim_9km.T,2),nanmean(sim_9km.dz,2),'k');
ylim([0 60])
set(gca,'ydir','reverse')
% title('Temperature salinity')
% legend('data','old','new','9km','location','southeast')
xlabel('Temperature C')

% figure
subplot 223
plot(nanmean(data_old.u,2),nanmean(data_old.p,2))
hold on;plot(nanmean(sim_old.u,2),nanmean(sim_old.dz,2));
plot(nanmean(sim_mcphee.u,2),nanmean(sim_mcphee.dz,2));
plot(nanmean(sim_9km.u,2),nanmean(sim_9km.dz,2),'k');
ylim([0 60])
xlim([-0.03 0.03])
set(gca,'ydir','reverse')
% legend('data','old','new','9km','location','southwest')
xlabel('eastward Vel m/s')

subplot 224
plot(nanmean(data_old.v,2),nanmean(data_old.p,2))
hold on;plot(nanmean(sim_old.v,2),nanmean(sim_old.dz,2));
plot(nanmean(sim_mcphee.v,2),nanmean(sim_mcphee.dz,2));
plot(nanmean(sim_9km.v,2),nanmean(sim_9km.dz,2),'k');
ylim([0 60])
xlim([-0.03 0.03])
set(gca,'ydir','reverse')
% title('northward')
% legend('data','old','new','9km','location','southwest')
xlabel('Northward Vel m/s')

for n = 1:length(data_old.time)
    data_10_u(n) = interp1(data_old.p(~isnan(data_old.p(:,n)),n),...
        data_old.u(~isnan(data_old.p(:,n)),n),10);
    data_10_v(n) = interp1(data_old.p(~isnan(data_old.p(:,n)),n)...
        ,data_old.v(~isnan(data_old.p(:,n)),n),10);
    old_10_u(n) = interp1(sim.dz,sim_old.u(:,n),10);
    old_10_v(n) = interp1(sim.dz,sim_old.v(:,n),10);
    mp_10_u(n) = interp1(sim.dz,sim_mcphee.u(:,n),10);
    mp_10_v(n) = interp1(sim.dz,sim_mcphee.v(:,n),10);
end
for n = 1:length(data_old.time)
    
    km9_10_u(n) = interp1(sim.dz,sim_9km.u(:,n),10);
    km9_10_v(n) = interp1(sim.dz,sim_9km.v(:,n),10);
end

figure
subplot 211;hold on
plot(data_old.time,data_10_u,data_old.time,old_10_u...
    ,data_old.time,mp_10_u)
plot(data_9km.time,km9_10_u,'k')
datetick('x','mmm');axis tight;ylim ([-0.2 0.2]);
ylabel('eastward ms^-^1')
legend('data','old','new','9km','Orientation','horizental')
subplot 212;hold on
plot(data_old.time,data_10_v,data_old.time,old_10_v...
    ,data_old.time,mp_10_v)
plot(data_9km.time,km9_10_v,'k')
datetick('x','mmm');axis tight;ylim ([-0.2 0.2]);
ylabel('northward ms^-^1')
title('vel @ 10m')

figure
subplot 211;hold on
plot(data_old.time,data_old.uflux./h,'k')
plot(data_old.time,sim_mcphee.uflux./h,'b')
plot(data_9km.time,sim_9km.uflux./h,'r')
datetick('x','mmm');axis tight;ylim ([-0.2 0.2]);
legend('data','A1','A2','Orientation','horizental')
ylabel('eastward ms^-^1')
title('mean vel from 5-60m')

subplot 212;hold on
plot(data_old.time,data_old.vflux./h,'k')
plot(data_old.time,sim_mcphee.vflux./h,'b')
plot(data_9km.time,sim_9km.vflux./h,'r')
datetick('x','mmm');axis tight;ylim ([-0.2 0.2]);
datetick('x','mmm');axis tight;ylim ([-0.2 0.2]);
ylabel('northward ms^-^1')


corrcoef(data_old.vflux./h,sim_old.vflux./h)
corrcoef(data_old.vflux./h,sim_mcphee.vflux./h)
corrcoef(data_old.vflux./h,sim_9km.vflux./h)
corrcoef(data_old.uflux./h,sim_old.uflux./h)
corrcoef(data_old.uflux./h,sim_mcphee.uflux./h)
corrcoef(data_old.uflux./h,sim_9km.uflux./h)

