clear;close all;clc;

old_dr = [10.00, 10.00, 10.00, 10.00, 10.00, 10.00, 10.00, 10.01,...
    10.03, 10.11, 10.32, 10.80, 11.76, 13.42, 16.04 , 19.82, 24.85,...
    31.10, 38.42, 46.50, 55.00, 63.50, 71.58, 78.90, 85.15, 90.18,...
    93.96, 96.58, 98.25, 99.25,100.01,101.33,104.56,111.33,122.83,...
    139.09,158.94,180.83,203.55,226.50,249.50,272.50,295.50,318.50,...
    341.50,364.50,387.50,410.50,433.50,456.50];

new_dr = [2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2.50,3.12,...
    3.90,4.88,6.10,7.62,9.53,11.92,14.90,18.62,23.28,...
    29.10,36.37,45.47,56.84,71.05,88.81,111.02,138.77,173.47,216.84,271.05,...
    338.81,423.51,529.39,661.74,787.18,853.97,1152.74];

%calculating tracers depth (same as U and V)
for i=2:50
    
    dts_old(1) = 5;
    ts_old(1) = 5;
    dts_old(i) = old_dr(i)/2+old_dr(i-1)/2;
    ts_old(i) = sum(dts_old(1:i));
    dts_new(1) = 1;
    dts_new(i) = new_dr(i)/2 + new_dr(i-1)/2;
    ts_new(1) = 1;
    ts_new(i) = sum(dts_new(1:i));
    
end

cd /media/arash/MITgcmfiles/MITgcm/MITgcm/MITgcm_contrib/arctic/cs_18km/input/

%doing DIFFKR & PHC_SALT_JAN PHC_THETA_JAN & WGHC* & WOA*
do_3d_fileds = 0;
while do_3d_fileds == 1
    
    cd 18km_y_independ
    
    mkdir('revised_vgrid_3d')
    mkdir('old_grid_3d')
    
    list_3d = FileIn('x50');
    for ii = 1:length(list_3d)
        
        temp_3d_old = readbin(list_3d{ii},[420,384,50]);
        
        for nn = 1:420
            for mm = 1:384
                
                temp_3d_new(nn,mm,:) = interp1(ts_old,squeeze(temp_3d_old(nn,mm,:)),ts_new,'pchip');
                
            end
        end
        
        movefile(list_3d{ii},'old_grid_3d/')
        
        cd revised_vgrid_3d
        
        writebin(list_3d{ii},temp_3d_new)
        
        cd ..
        
        clear temp_3d_new ; clear temp_3d_old
    end
    
    cd ..
    break
end

%doing OBCs
do_obcs = 0;
while do_obcs == 1
    
    cd obcs
    
    listobcs={'OBNs_arctic_420x384_19792019.stable','OBNt_arctic_420x384_19792019.stable',...
        'OBNu_arctic_420x384_19792019.bin','OBNv_arctic_420x384_19792019.balance',...
        'OBWs_arctic_420x384_19792019.stable','OBWt_arctic_420x384_19792019.stable',...
        'OBWu_arctic_420x384_19792019.bin','OBWv_arctic_420x384_19792019.bin',...
        'OBEs_arctic_420x384_19792019.stable','OBEt_arctic_420x384_19792019.stable',...
        'OBEu_arctic_420x384_19792019.bin','OBEv_arctic_420x384_19792019.bin'};
    
    
    nx=420;ny=384;nz=50;
    nL=[nx.*ones(1,4) ny.*ones(1,8)];
    nt = 494;
    
    mkdir('obcs_vgrid')
    
    for ii = 1:size(listobcs,2)
        
        obc_old=readbin(listobcs{ii},[nL(ii) nz nt]);
        
        for mm = 1:size(obc_old,1)
            for oo = 1:size(obc_old,3)
                
                obc_new(mm,:,oo) = interp1(ts_old,squeeze(obc_old(mm,:,oo)),ts_new,'pchip');
                
            end
        end
        
        cd obcs_vgrid
        
        writebin(listobcs{ii},obc_new)
        
        cd ..
        
        clear obc_old; clear obc_new;
        
    end
    
    cd ..
    break
end

% do Tref
do_tref = 0;
while do_tref == 1;
    tref_old =  [23 23 23.,22 22 22.,21.,20 20.,19.,18 18.,17.,16 16.,15.,14.,13.,...
        12.,11.,9 9.,8.,7.,6 6.,5 5.,4 4 4.,3 3 3, 2, 2 2 2, ...
        1 1 1 1 1 1 1 1 1 1 1 1];
    
    tref_new = interp1(ts_old,tref_old,ts_new,'pchip');
    tref_new = floor(tref_new);
    
    break
end