clear all;clc,close all;

input_address = pwd;


load('/media/arash/SSD128/Post proc/inputs/constants/coord.mat')

tic
%inputs
number_days = 2801;
number_layers = 50;

min_lon_west = -90;


%limiting the simulation results saves compution time
[id_row,id_col]=find(lon<min_lon_west);
id_row=min(id_row);id_col=min(id_col);
id_row=size(lon,1)-id_row+1;
id_col=size(lon,2)-id_col+1;




%loading should be part by part duo to huge size of files
cd (input_address)

%%
load('theta_field.mat')
display('loading theta file')


for j=1:number_layers
    for i=1:number_days
        temp1=theta_field(:,:,j,i);
%         temp2=data2(:,:,j,i);
%         temp3=data3(:,:,j,i);
%         temp4=data4(:,:,j,i);
        temp1=temp1(lon<min_lon_west);
%         temp2=temp2(lon<min_lon_west);
%         temp3=temp3(lon<min_lon_west);
%         temp4=temp4(lon<min_lon_west);
        
        theta_field_t(:,:,j,i) = reshape(temp1,id_row,id_col);
%         salt_field_t(:,:,j,i) = reshape(temp2,id_row,id_col);        
%         u_field_m_t(:,:,j,i) = reshape(temp3,id_row,id_col);
%         v_field_m_t(:,:,j,i) = reshape(temp4,id_row,id_col);
    end
end

display('saving theta file')
save ('theta_field_t','theta_field_t','-v7.3')
clear theta_field_t,clear theta_field,clear temp1;

%%
load('salt_field.mat')
display('loading salt file')


for j=1:number_layers
    for i=1:number_days
%         temp1=data1(:,:,j,i);
        temp2=salt_field(:,:,j,i);
%         temp3=data3(:,:,j,i);
%         temp4=data4(:,:,j,i);
%         temp1=temp1(lon<min_lon_west);
        temp2=temp2(lon<min_lon_west);
%         temp3=temp3(lon<min_lon_west);
%         temp4=temp4(lon<min_lon_west);
        
%         theta_field_t(:,:,j,i) = reshape(temp1,id_row,id_col);
        salt_field_t(:,:,j,i) = reshape(temp2,id_row,id_col);
        
%         u_field_m_t(:,:,j,i) = reshape(temp3,id_row,id_col);
%         v_field_m_t(:,:,j,i) = reshape(temp4,id_row,id_col);
    end
end

display('saving salt file')
save ('salt_field_t','salt_field_t','-v7.3')
clear salt_field_t,clear salt_field,clear temp1;

%%
load('u_field_m.mat')
display('loading U file')


for j=1:number_layers
    for i=1:number_days
%         temp1=data1(:,:,j,i);
%         temp2=salt_field(:,:,j,i);
        temp3=u_field_m(:,:,j,i);
%         temp4=data4(:,:,j,i);
%         temp1=temp1(lon<min_lon_west);
%         temp2=temp2(lon<min_lon_west);
        temp3=temp3(lon<min_lon_west);
%         temp4=temp4(lon<min_lon_west);
        
%         theta_field_t(:,:,j,i) = reshape(temp1,id_row,id_col);
%         salt_field_t(:,:,j,i) = reshape(temp2,id_row,id_col);
        
        u_field_m_t(:,:,j,i) = reshape(temp3,id_row,id_col);
%         v_field_m_t(:,:,j,i) = reshape(temp4,id_row,id_col);
    end
end

display('saving U file')
save ('u_field_m_t','u_field_m_t','-v7.3')
clear u_field_m_t,clear u_field_m,clear temp1;

%%
load('v_field_m.mat')
display('loading V file')


for j=1:number_layers
    for i=1:number_days
%         temp1=data1(:,:,j,i);
%         temp2=salt_field(:,:,j,i);
%         temp3=u_field_m(:,:,j,i);
        temp4=v_field_m(:,:,j,i);
%         temp1=temp1(lon<min_lon_west);
%         temp2=temp2(lon<min_lon_west);
%         temp3=temp3(lon<min_lon_west);
        temp4=temp4(lon<min_lon_west);
        
%         theta_field_t(:,:,j,i) = reshape(temp1,id_row,id_col);
%         salt_field_t(:,:,j,i) = reshape(temp2,id_row,id_col);
        
%         u_field_m_t(:,:,j,i) = reshape(temp3,id_row,id_col);
        v_field_m_t(:,:,j,i) = reshape(temp4,id_row,id_col);
    end
end

display('saving V file')
save ('v_field_m_t','v_field_m_t','-v7.3')
clear v_field_m_t,clear v_field_m,clear temp1;

load('p_hydro.mat')
display('loading p_hydro file')


for j=1:number_layers
    for i=1:number_days
        temp1=p_hydro(:,:,j,i);
%         temp2=data2(:,:,j,i);
%         temp3=data3(:,:,j,i);
%         temp4=data4(:,:,j,i);
        temp1=temp1(lon<min_lon_west);
%         temp2=temp2(lon<min_lon_west);
%         temp3=temp3(lon<min_lon_west);
%         temp4=temp4(lon<min_lon_west);
        
        p_hydro_t(:,:,j,i) = reshape(temp1,id_row,id_col);
%         salt_field_t(:,:,j,i) = reshape(temp2,id_row,id_col);        
%         u_field_m_t(:,:,j,i) = reshape(temp3,id_row,id_col);
%         v_field_m_t(:,:,j,i) = reshape(temp4,id_row,id_col);
    end
end

display('p_hydro file')
save ('p_hydro_t','p_hydro_t','-v7.3')
clear p_hydro_t,clear p_hydro,clear temp1;
toc