function [stat_ice_z , sim_ice_z] = Step04_comparison_36km_station_timehistory(i_area_t,lat,lon)
%this function calculates given ice area and coords, the interpolated sea
%ice cover at RICEX stations , work folder is sea_ice_cover

%loading inputs from the code
load ('/media/arash/SSD128/Post proc/inputs/constants/ricex.mat')
load ('/media/arash/SSD128/Post proc/inputs/constants/2006_2013.mat')
load ('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')

%n=dayss from start

n_days=size(i_area_t,3);

% changing i_area format and clearing i_area
for n=1:size(i_area_t,3)
    
    ice_area{n}=double(i_area_t(:,:,n));
    
end
clear i_area_t.mat

% projecting ricex points

for station_id=1:size(ricex,1)-1
    
    st_lon(station_id) = -ricex{station_id+1,3};
    st_lat(station_id) = ricex{station_id+1,2};
    [station_x(station_id) ,station_y(station_id)] = mfwdtran(mstruct,st_lat(station_id),st_lon(station_id));
    
end

% Fixing Sat data and simulation data projection

for n=1:n_days
    
    z{n}(z{n}==120)=NaN;z{n}(z{n}==110)=100;
    [sat_x ,sat_y ,sat_z{n}] = mfwdtran(mstruct,sat_lat,sat_lon,z{n});
    [sim_x ,sim_y ,sim_z{n}] = mfwdtran(mstruct,lat,lon,ice_area{n});
    
end

% Pre-allocating sat_stat_ice and sim_stat_ice
stat_ice_z = zeros(size(ricex,1)-1,n_days);
sim_ice_z = zeros(size(ricex,1)-1,n_days);

for n=1:n_days
    
    % interpolation
    
    stat_ice_z(:,n) = griddata(sim_x,sim_y,sim_z{n},station_x,station_y);
    sim_ice_z(:,n) = griddata(sat_x,sat_y,sat_z{n},station_x,station_y);
    
    n
end