function [itp_iu_sim,itp_iv_sim,itp_name_sim,itp_date_sim] = Step06_comparison_36km_itp_SI_corr(iu_field_m_t,iv_field_m_t,lat_t,lon_t,sim_start_date)

% function itp_iu_sim,itp_iv_sim,itp_name_sim,itp_date_sim] = Step06_comparison_36km_itp_SI_corr(iu_field_m_t,iv_field_m_t,lat_t,lon_t,sim_start_date)
% calculates model velocities on ITP path, work folder sea ice vel

load('/media/arash/SSD128/Post proc/inputs/constants/ITP_ice_vel_filtered.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')

% load('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')


% Reshaping the lon-lat
lat_t_r=reshape(lat_t,size(lat_t,1)*size(lat_t,2),1);
lon_t_r=reshape(lon_t,size(lon_t,1)*size(lon_t,2),1);


for n=1:size(iu_field_m_t,3)
    
    %setting date
    
    current_date=sim_start_date+n;
    
    %making the interpolation surface
    
    iu_field_t_r(:,:,n)=reshape(double(iu_field_m_t(:,:,n)),size(lat_t,1)*size(lat_t,2),1);
    iv_field_t_r(:,:,n)=reshape(double(iv_field_m_t(:,:,n)),size(lat_t,1)*size(lat_t,2),1);
    
    %     forward projaction of fields
    [x_t_r ,y_t_r ,iu_field_t_r_z(:,:,n)] = mfwdtran(mstruct,lat_t_r,lon_t_r,iu_field_t_r(:,:,n));
    [x_t_r ,y_t_r ,iv_field_t_r_z(:,:,n)] = mfwdtran(mstruct,lat_t_r,lon_t_r,iv_field_t_r(:,:,n));

% iu_field_t_r_z = iu_field_t_r;
% iv_field_t_r_z = iv_field_t_r;
% x_t_r = lon_t_r;
% y_t_r = lat_t_r;
    
    sim_surf_u=scatteredInterpolant(x_t_r ,y_t_r ,iu_field_t_r_z(:,:,n),'linear','nearest');
    sim_surf_v=scatteredInterpolant(x_t_r ,y_t_r ,iv_field_t_r_z(:,:,n),'linear','nearest');
    
    for itp_n=1:size(itp_date_obs,2)
        for num_days=1:size(itp_date_obs{itp_n},2)
            if current_date == itp_date_obs{itp_n}(num_days)
                
%                 forward projection of itp locations
                [itp_x_obs{itp_n}(num_days) ,itp_y_obs{itp_n}(num_days)]  = mfwdtran(mstruct,itp_lat_obs{itp_n}(num_days),itp_lon_obs{itp_n}(num_days));

% itp_x_obs{itp_n}(num_days) = itp_lon_obs{itp_n}(num_days);
% itp_y_obs{itp_n}(num_days) = itp_lat_obs{itp_n}(num_days);
                
                itp_iu_sim_z{itp_n}(num_days) = sim_surf_u(itp_x_obs{itp_n}(num_days),itp_y_obs{itp_n}(num_days));
                itp_iv_sim_z{itp_n}(num_days) = sim_surf_v(itp_x_obs{itp_n}(num_days),itp_y_obs{itp_n}(num_days));
                
                %inv projection of fields
                %                 [itp_lat_obs{itp_n}(num_days) ,itp_lon_obs{itp_n}(num_days) ,itp_iu_sim{itp_n}(num_days)] = ...
                %                     minvtran(mstruct,itp_x_obs{itp_n}(num_days) ,itp_y_obs{itp_n}(num_days) ,itp_iu_sim_z{itp_n}(num_days));
                %                 [itp_lat_obs{itp_n}(num_days) ,itp_lon_obs{itp_n}(num_days) ,itp_iv_sim{itp_n}(num_days)] = ...
                %                     minvtran(mstruct,itp_x_obs{itp_n}(num_days) ,itp_y_obs{itp_n}(num_days) ,itp_iv_sim_z{itp_n}(num_days));
                %
                
                itp_iu_sim{itp_n}(num_days) = itp_iu_sim_z{itp_n}(num_days) ;
                itp_iv_sim{itp_n}(num_days) = itp_iv_sim_z{itp_n}(num_days) ;
                
            end
        end
    end
    n
end

itp_name_sim = itp_name_obs;
itp_date_sim = itp_date_obs;

end
% save('ITP_Ice_vel_sim','itp_iu_sim','itp_iv_sim','itp_name_sim','itp_date_sim')


