clear, close all,clc

%cd ('/media/arash/SSD128/Post proc/sal_tem')
output_address = pwd
input_address = pwd

%loading inputs from the code
load ('/media/arash/SSD128/Post proc/inputs/constants/coord.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/itp_ts_obs.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/dz_new.mat')


%% changing theta and salt format and stroing them at given date and layer
% as salt_sim_date{date,layer}

% load theta_field_2005.mat;
% theta_field_t = theta_field_2005;
% clear theta_field_2005;

cd(input_address)

%load('/media/arash/SSD/Post proc/inputs/T19/theta_field')
load('theta_field')

num_sim_date = size(theta_field,4);
num_ver_layer = size(theta_field,3);
sim_3d_start_date=datenum(2006,1,1)-1;

for sim_date  = 1:num_sim_date
    
    for m=1:num_ver_layer
        
        theta_sim{sim_date,m}=theta_field(:,:,m,sim_date);
    end
    
end

clear theta_field
%
% load salt_field_2005.mat;
% salt_field_t = salt_field_2005;
% clear salt_field_2005;

%load('/media/arash/SSD128/Post proc/inputs/T19/salt_field')
load('salt_field')

for sim_date  = 1:num_sim_date
    
    for m=1:num_ver_layer
        
        salt_sim{sim_date,m}=salt_field(:,:,m,sim_date);
    end
    
end

clear salt_field
%%

%% fixing the depth
dh(1) = 0;
dh(2:size(dz_new,2)+1) = dz_new ;

% tracers are at half the depth incerements

for i=1:num_ver_layer+1
    
    sim_depth_w(i)=sum(dh(1:i));
    
end

for i=1:num_ver_layer
    
    sim_depth(i)=(sim_depth_w(i)+sim_depth_w(i+1))/2;
    
end
%%

%% Fixing simulation data
for n=1:num_sim_date
    for m=1:num_ver_layer
        theta_sim{n,m} = reshape(double(theta_sim{n,m}),size(theta_sim{n,m},1)*size(theta_sim{n,m},2),1);
%         salt_sim{n,m} = reshape(double(salt_sim{n,m}),size(salt_sim{n,m},1)*size(salt_sim{n,m},2),1);
    end
end

for n=1:num_sim_date
    for m=1:num_ver_layer
%         theta_sim{n,m} = reshape(double(theta_sim{n,m}),size(theta_sim{n,m},1)*size(theta_sim{n,m},2),1);
        salt_sim{n,m} = reshape(double(salt_sim{n,m}),size(salt_sim{n,m},1)*size(salt_sim{n,m},2),1);
    end
end



% Reshaping the lon-lat

lat_r=reshape(lat,size(lat,1)*size(lat,2),1);
lon_r=reshape(lon,size(lon,1)*size(lon,2),1);


%%main code
display('starting the steps')

do_stations_too = 0;
while do_stations_too == 1;
    load ('/media/arash/SSD128/Post proc/inputs/constants/ricex.mat')
    
    for n=1:num_sim_date
        display(sprintf('time step %d / 2801',n))
        
        sim_date = n+sim_3d_start_date;
        
        for m=1:num_ver_layer
            
            
            % projecting the data forward
            [x_t_r ,y_t_r ,theta_sim_z] = mfwdtran(mstruct,lat_t_r ,lon_t_r ,theta_sim{n,m});
            [x_t_r ,y_t_r ,salt_sim_z] = mfwdtran(mstruct,lat_t_r ,lon_t_r ,salt_sim{n,m});
            % interpolation
            
            sim_theta_surf = scatteredInterpolant(x_t_r,y_t_r,theta_sim{n,m},'linear','nearest');
            sim_salt_surf = scatteredInterpolant(x_t_r,y_t_r,salt_sim{n,m},'linear','nearest');
            
            for o=1:length(itp_date_obs)
                
                if itp_date_obs{o} >= sim_date && itp_date_obs{o} <= (sim_date+1)
                    
                    itp_date_sim{o} = sim_date - sim_3d_start_date;
                    itp_lat_sim{o} = itp_lat_obs{o};
                    itp_lon_sim{o} = itp_lon_obs{o};
                    itp_p_db_sim{o} =  sim_depth;
                    itp_num_sim{o} = itp_num_obs{o};
                    
                    % projecting points forward
                    [itp_x ,itp_y] = mfwdtran(mstruct,itp_lat_sim{o},itp_lon_sim{o});
                    
                    itp_s_sim_z = sim_salt_surf(itp_x,itp_y);
                    itp_t_sim_z = sim_theta_surf(itp_x,itp_y);
                    
                    % projecting the points backward
                    [itp_lat_sim{o}, itp_lon_sim{o}, itp_s_sim{o}(m,1)] = minvtran(mstruct,itp_x ,itp_y, itp_s_sim_z);
                    [itp_lat_sim{o}, itp_lon_sim{o}, itp_t_sim{o}(m,1)] = minvtran(mstruct,itp_x ,itp_y, itp_t_sim_z);
                    
                    
                end
            end
            
            for p=1:size(ricex,1)-1
                
                %forward proj of station location
                [st_x ,st_y] = mfwdtran(mstruct,ricex{p+1,2},-ricex{p+1,3});
                
                station_s_z = sim_salt_surf(st_x,st_y);
                station_t_z = sim_theta_surf(st_x,st_y);
                
                %back proj of station data
                
                [st_lt{p}, st_ln{p}, station_ts{p,n}(m,1)] = minvtran(mstruct,itp_x ,itp_y, station_s_z);
                [st_lt{p}, st_ln{p}, station_ts{p,n}(m,2)] = minvtran(mstruct,itp_x ,itp_y, station_t_z);
                
            end
        end
    end
    save ('station_ts','station_ts','sim_depth')
    break
end

do_itp_only = 1;
while do_itp_only == 1;
    for n=1:num_sim_date
        display(sprintf('time step %d / 2801',n))
        
        sim_date = n+sim_3d_start_date;
        
        for m=1:num_ver_layer
            
            % projecting the data forward
            [x_t_r ,y_t_r ,theta_sim_z] = mfwdtran(mstruct,lat_r ,lon_r ,theta_sim{n,m});
            [x_t_r ,y_t_r ,salt_sim_z] = mfwdtran(mstruct,lat_r ,lon_r ,salt_sim{n,m});
            % interpolation
            
            sim_theta_surf = scatteredInterpolant(x_t_r,y_t_r,theta_sim_z,'linear','nearest');
            sim_salt_surf = scatteredInterpolant(x_t_r,y_t_r,salt_sim_z,'linear','nearest');
            
            for o=1:length(itp_date_obs)
                
                if itp_date_obs{o} >= sim_date && itp_date_obs{o} <= (sim_date+1)
                    
                    itp_date_sim{o} = sim_date - sim_3d_start_date;
                    itp_lat_sim{o} = itp_lat_obs{o};
                    itp_lon_sim{o} = itp_lon_obs{o};
                    itp_p_db_sim{o} =  sim_depth;
                    itp_num_sim{o} = itp_num_obs{o};
                    
                    % projecting points forward
                    [itp_x ,itp_y] = mfwdtran(mstruct,itp_lat_sim{o},itp_lon_sim{o});
                    
                    itp_s_sim_z = sim_salt_surf(itp_x,itp_y);
                    itp_t_sim_z = sim_theta_surf(itp_x,itp_y);
                    
                    % projecting the points backward
                    [itp_lat_sim{o}, itp_lon_sim{o}, itp_s_sim{o}(m,1)] = minvtran(mstruct,itp_x ,itp_y, itp_s_sim_z);
                    [itp_lat_sim{o}, itp_lon_sim{o}, itp_t_sim{o}(m,1)] = minvtran(mstruct,itp_x ,itp_y, itp_t_sim_z);
                    
                end
            end
        end
    end
    break
end

%% saving

save ('itp_ts_sim_T40','itp_date_sim','itp_lat_sim','itp_lon_sim','itp_p_db_sim','itp_num_sim','itp_s_sim','itp_t_sim')
